import dis
from io import StringIO
from types import CodeType

CODE_FIELDS = (
    "argcount",
    "kwonlyargcount",
    "nlocals",
    "stacksize",
    "flags",
    "code",
    "consts",
    "names",
    "varnames",
    "filename",
    "name",
    "firstlineno",
    "lnotab",
    "freevars",
    "cellvars",
)

def assemble(*instrs):
    buf = StringIO()
    for op, arg in instrs:
        buf.write(chr(dis.opmap[op]) + chr(arg or 0))

    return bytes(ord(char) for char in buf.getvalue())

def reassemble_code(code, **options):
    fields = {field: getattr(code, f"co_{field}") for field in CODE_FIELDS}
    fields.update(options)
    
    code = CodeType(**fields)
    return func
